Subject: bug#32367: 2.2.4 hangs when a script uses a module that calls sigaction

From: Derek Upham <[email-masked]>
Date: Sat, 27 Oct 2018 07:16:44 -0700

I’m not having luck with the patch.  Current commit is bbe6daa76 (stable-2.2).  Running

  ./autogen.sh && ./configure --prefix=$HOME/guile-2.2 PKG_CONFIG_PATH=/usr/local/lib/pkgconfig:/usr/lib64/pkgconfig:/usr/lib/pkgconfig:/usr/share/pkgconfig && make clean all install

builds clean and I can repro the problem with

  $HOME/guile-2.2/bin/guile -s ../signal-test

The patch applies cleanly, but then the same build commands fail:

    GUILEC sxml/apply-templates.go
  Backtrace:
  In ice-9/boot-9.scm:
     222:17 19 (map1 (((sxml ssax)) ((sxml xpath) #:hide (filter))))
    2958:17 18 (resolve-interface (sxml ssax) #:select _ #:hide _ #:prefix _ #:renamer _ #:version _)
  In ice-9/threads.scm:
      390:8 17 (_ _)
  In ice-9/boot-9.scm:
    2881:28 16 (_ #<mutex 559a33ee4f80>)
  In ice-9/threads.scm:
      390:8 15 (_ _)
  In ice-9/boot-9.scm:
    3171:20 14 (_ #<mutex 559a33ee4f80>)
     2312:4 13 (save-module-excursion #<procedure 559a3417a360 at ice-9/boot-9.scm:3172:21 ()>)
    3191:26 12 (_)
  In unknown file:
            11 (primitive-load-path "sxml/ssax" #<procedure 559a33dc3c60 at ice-9/boot-9.scm:3178:37 ()>)
  In ice-9/eval.scm:
     721:20 10 (primitive-eval (define-module (sxml ssax) #:use-module (sxml ssax input-parse) #:use-module (srfi srfi-1) #:use-module (srfi srfi-13) #:export (# # # # # # ?)))
  In ice-9/psyntax.scm:
    1235:36  9 (expand-top-sequence ((define-module (sxml ssax) #:use-module (sxml ssax input-parse) #:use-module (srfi srfi-1) #:use-module (srfi srfi-13) #:export (# # ?))) _ ?)
    1182:24  8 (parse _ (("placeholder" placeholder)) ((top) #(ribcage () () ())) _ e (eval) (hygiene #{ g95}#))
     285:10  7 (parse _ (("placeholder" placeholder)) (()) _ c&e (eval) (hygiene #{ g95}#))
  In ice-9/eval.scm:
     293:34  6 (_ #<module (#{ g95}#) 559a34125000>)
  In ice-9/boot-9.scm:
     3032:4  5 (define-module* _ #:filename _ #:pure _ #:version _ #:imports _ #:exports _ #:replacements _ #:re-exports _ #:autoloads _ #:duplicates _ #:transformer _)
    3045:24  4 (_)
     222:17  3 (map1 (((sxml ssax input-parse)) ((srfi srfi-1)) ((srfi srfi-13))))
     2961:6  2 (resolve-interface _ #:select _ #:hide _ #:prefix _ #:renamer _ #:version _)
  In unknown file:
             1 (scm-error misc-error #f "~A ~S" ("no code for module" (sxml ssax input-parse)) #f)
  In ice-9/boot-9.scm:
     752:25  0 (dispatch-exception _ _ _)

  ice-9/boot-9.scm:752:25: In procedure dispatch-exception:
  no code for module (sxml ssax input-parse)

Mark H Weaver <[email-masked]> writes:

> I've attached a preliminary patch to fix this bug.
>
>       Mark

-- 
Derek Upham
[email-masked]